//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 1
#property indicator_color1   PaleVioletRed
#property indicator_width1   2

extern bool  alertsOn        = false;
extern bool  alertsOnCurrent = true;
extern bool  alertsMessage   = true;
extern bool  alertsSound     = false;
extern bool  alertsEmail     = false;

double       haTrend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()   { SetIndexBuffer(0,haTrend); return(0); }
int deinit() {                            return(0); }
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--) haTrend[i] = getHaTrend(i);
   manageAlerts();
   return(0);      
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//


double workHa[][4];
double getHaTrend(int i)
{
   if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);

      //
      //
      //
      //
      //
      
      double haOpen; int r = Bars-i-1;

      if (i>0)
             haOpen  = (workHa[r-1][2] + workHa[r-1][3])/2.0;
      else   haOpen  = Open[i]+Close[i];
      double haClose = (Open[i] + High[i] + Low[i] + Close[i]) / 4.0;
      double haHigh  = MathMax(High[i], MathMax(haOpen,haClose));
      double haLow   = MathMin(Low[i] , MathMin(haOpen,haClose));

      if(haOpen  <haClose) { workHa[r][0] = haLow;  workHa[r][1] = haHigh; } 
      else                 { workHa[r][0] = haHigh; workHa[r][1] = haLow;  } 
                             workHa[r][2] = haOpen;
                             workHa[r][3] = haClose;

      //
      //
      //
      //
      //
      
      if (haClose>haOpen) return( 1);
      if (haClose<haOpen) return(-1);
                          return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
            
      if (haTrend[whichBar] != haTrend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (haTrend[whichBar] ==  1) doAlert(time1,mess1," HA trend changed to up");
            if (haTrend[whichBar] == -1) doAlert(time1,mess1," HA trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" HA trend binary",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

